Subject: Re: [v3 2/2] dsa: mv88e6xxx: make serdes SGMII/Fiber output amplitude configurable

From: Marek Behún <[email-masked]>
Date: Tue, 7 Dec 2021 20:27:33 +0100

On Tue,  7 Dec 2021 20:07:30 +0100
Holger Brunck <[email-masked]> wrote:

> The mv88e6352, mv88e6240 and mv88e6176  have a serdes interface. This patch
> allows to configure the output swing to a desired value in the
> devicetree node of the port. As the chips only supports eight dedicated
> values we return EINVAL if the value in the DTS does not match.
> 
> CC: Andrew Lunn <[email-masked]>
> CC: Jakub Kicinski <[email-masked]>
> CC: Marek Behún <[email-masked]>
> Signed-off-by: Holger Brunck <[email-masked]>

Holger, Andrew,

there is another issue with this, which I only realized yesterday. What
if the different amplitude needs to be set only for certain SerDes
modes?

I am bringing this up because I discovered that on Turris Mox we need
to increase SerDes output amplitude when A3720 SOC is connected
directly to 88E6141 switch, but only for 2500base-x mode. For
1000base-x, the default amplitude is okay. (Also when the SOC is
connected to 88E6190, the amplitude does not need to be changed at all.)

I plan to solve this in the comphy driver, not in device-tree.

But if the solution is to be done in DTS, shouldn't there be a
possibility to define the amplitude for a specific serdes mode only?

For example
  serdes-2500base-x-tx-amplitude-millivolt
or
  serdes-tx-amplitude-millivolt-2500base-x
or
  serdes-tx-amplitude-millivolt,2500base-x
?

What do you think?

Marek